/********************************** (C) COPYRIGHT *******************************
 * File Name          : ch32v30x_it.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main Interrupt Service Routines.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/
#include "ch32v30x_it.h"

ITStatus aa,bb,cc,dd;
uint32_t tmpreg = 0;
u8 icount =0;
u8 itmp = 0;


void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void RTC_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
//void USART2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
// USART2 ж
void DMA1_Channel6_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
// USART2 ж
void DMA1_Channel7_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));


/*********************************************************************
 * @fn      NMI_Handler
 *
 * @brief   This function handles NMI exception.
 *
 * @return  none
 */
void NMI_Handler(void)
{
}

/*********************************************************************
 * @fn      HardFault_Handler
 *
 * @brief   This function handles Hard Fault exception.
 *
 * @return  none
 */
void HardFault_Handler(void)
{
    while(1)
    {
    }
}

/*********************************************************************
 * @fn      RTC_IRQHandler
 *
 * @brief   This function handles RTC Handler.
 *
 * @return  none
 */
void RTC_IRQHandler(void)
{
    if(RTC_GetITStatus(RTC_IT_SEC) != RESET) /* Seconds interrupt */
    {
        RTC_Get();
    }
    if(RTC_GetITStatus(RTC_IT_ALR) != RESET) /* Alarm clock interrupt */
    {
        RTC_ClearITPendingBit(RTC_IT_ALR);
        RTC_Get();
    }

    RTC_ClearITPendingBit(RTC_IT_SEC | RTC_IT_OW);
    RTC_WaitForLastTask();
}

void DMA1_Channel6_IRQHandler(void)
{
    //1. ж
    aa = DMA_GetITStatus(DMA1_IT_GL6);
    bb = DMA_GetITStatus(DMA1_IT_TC6);
    cc = DMA_GetITStatus(DMA1_IT_HT6);
    dd = DMA_GetITStatus(DMA1_IT_TE6);
    tmpreg = DMA1->INTFR;
    if(DMA_GetITStatus(DMA1_IT_TC6) == RESET)
    {
        icount ++;
        return;
    }
    switch(rxFlag)
    {
    case USART_RX_FLG0:
        //жǷEB
        if (RxBuffer1[rxBufPos] == 0xEB) {
            rxFlag = USART_RX_FLG1;
            rxChkSum^=RxBuffer1[rxBufPos];
            rxBufPos++;
        }
        else {
            rxFlag = USART_RX_FLG0;
            rxBufPos=0;
            rxChkSum=0;
        }
        //һν
        rxBufLen = 1;

        break;
    case USART_RX_FLG1:
        //жǷ90
        if (RxBuffer1[rxBufPos] == 0x90) {
            rxFlag = USART_RX_FLG2;
            rxChkSum^=RxBuffer1[rxBufPos];
            rxBufPos++;
        }
        else {
            rxFlag = USART_RX_FLG0;
            rxBufPos=0;
            rxChkSum=0;
        }
        //һν,յַ
        rxBufLen = 1;
        break;
    case USART_RX_FLG2:
        //жǷǱصַ
        if (RxBuffer1[rxBufPos] == USART_LOC_NOD_NUM) {
            rxFlag = USART_RX_FLG3;
            rxChkSum^=RxBuffer1[rxBufPos];
            rxBufPos++;
        }
        else {
            rxFlag = USART_RX_FLG0;
            rxBufPos=0;
            rxChkSum=0;
        }
        //һν
        rxBufLen = 1;
        break;
    case USART_RX_FLG3:
        //ݹ
        tmpreg =DMA1_Channel6->CNTR;
        switch(RxBuffer1[rxBufPos])
        {
        case USART_FUN_RTCSET:
            rxFlag = USART_RX_FLG4;
            rxChkSum^=RxBuffer1[rxBufPos];
            rxBufPos++;
            rxBufLen = 5;
            break;
        default:
            rxFlag = USART_RX_FLG0;
            rxBufPos=0;
            rxChkSum=0;
            rxBufLen = 1;
            break;
        }
        break;
        case USART_RX_FLG4:
            //жУǷȷ
            for(itmp = 0;itmp<4;itmp++)
            {
                rxChkSum = rxChkSum^RxBuffer1[rxBufPos];
                rxBufPos++;
            }
            if(RxBuffer1[rxBufPos] == rxChkSum){
                //ɣʱ
                RTC_SetUTC((u32*)(RxBuffer1+rxBufPos-4));
            }
            //ɵȴһΣ߳Ҳһ
            rxFlag = USART_RX_FLG0;
            rxBufPos=0;
            rxChkSum=0;
            rxBufLen = 1;
            break;
    }

    DMA_ClearITPendingBit(DMA1_IT_TC6);
    DMA_ClearITPendingBit(DMA1_IT_HT6);
    DMA_ClearITPendingBit(DMA1_IT_GL6);
    aa = DMA_GetITStatus(DMA1_IT_GL6);
    bb = DMA_GetITStatus(DMA1_IT_TC6);
    cc = DMA_GetITStatus(DMA1_IT_HT6);
    dd = DMA_GetITStatus(DMA1_IT_TE6);
    tmpreg = DMA1->INTFR;
    USART_DMA_RxSizeSet(rxBufLen,rxBufPos);
    tmpreg =DMA1_Channel6->CNTR;

}

void DMA1_Channel7_IRQHandler(void)
{
    // ʱرշͨ
    // жϣжӦúʱ̣ܶؼΪ´ж׼
    if(DMA_GetITStatus(DMA1_IT_TC7) != RESET)
    {
        DMA_ClearITPendingBit(DMA1_IT_TC7);
        //        USART_DMACmd(USART2, USART_DMAReq_Tx, ENABLE);
    }
}
