/*
 * rtc.h
 *
 *  Created on: Jul 30, 2022
 *      Author: Cuijf
 */

#ifndef USER_RTC_H_
#define USER_RTC_H_

#include "ch32v30x_rtc.h"
#include "ch32v30x_rcc.h"
#include "ch32v30x_bkp.h"

typedef struct
{
    vu8 hour;
    vu8 min;
    vu8 sec;

    vu16 w_year;
    vu8  w_month;
    vu8  w_date;
    vu8  week;
} _calendar_obj;

extern _calendar_obj calendar;

/* Exported_Functions */
u8 RTC_Init(void);
u8 Is_Leap_Year(u16 year);
u8 RTC_Alarm_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec);
u8 RTC_Get(void);
u8 RTC_Get_Week(u16 year, u8 month, u8 day);
u8 RTC_Set(u16 syear, u8 smon, u8 sday, u8 hour, u8 min, u8 sec);
u8 RTC_SetUTC(u32* pUtcTime);

#endif /* USER_RTC_H_ */
