/********************************** (C) COPYRIGHT *******************************
 * File Name          : usart.c
 * Author             : NUC
 * Version            : V1.0.0
 * Date               : 2022/07/30
 * Description        : Main program body.
 *******************************************************************************/


/*
 *@Note
 USARTʹDMAָ
  ͨѶӿڣUSART2_Tx(PA2)USART2_Rx(PA3)
 ע
     ӲӿڣPA2USART2_TX           PA3USART2_RX
     ͬλڽ
 */

#include "usart.h"

/* Global Variable */
u8 TxBuffer1[TXBUF_MAX] = {0};
u8 RxBuffer1[RXBUF_MAX] = {0};   /* USART2 Using  */
u8 TxCnt1 = 0, RxCnt1 = 0;
u8 Rxfinish1 = 0;
u8 halfChkSum = 0;  //֡ͷ+صַУϢ

u8 rxFlag = USART_RX_FLG0;
u8 rxBufPos = 0;
u8 rxChkSum = 0;
u8 rxBufLen = 0;

DMA_InitTypeDef DMA_TxInitStruct = {0};
DMA_InitTypeDef DMA_RxInitStruct = {0};

static void DMA7_NVIC_Config(void)
{
    NVIC_InitTypeDef NVIC_InitStructure = {0};
    NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

static void DMA6_NVIC_Config(void)
{
    NVIC_InitTypeDef NVIC_InitStructure = {0};
    NVIC_InitStructure.NVIC_IRQChannel = DMA1_Channel6_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}

/*********************************************************************
 * @fn      USARTx_CFG
 *
 * @brief   Initializes the USART2 & USART3 peripheral.
 *
 * @return  none
 */
void USARTx_CFG(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2 , ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA , ENABLE);

    /* USART2 TX-->A.2   RX-->A.3 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOA, &GPIO_InitStructure);


    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

    USART_Init(USART2, &USART_InitStructure);

    DMA_INIT();  //DMAĳʼ
    //ж
    DMA_ITConfig(DMA1_Channel7, DMA_IT_TC|DMA_IT_TE, ENABLE);
    DMA_ITConfig(DMA1_Channel6, DMA_IT_TC|DMA_IT_TE, ENABLE);
//    USART_ITConfig(USART2,USART_IT_TC,ENABLE);
//    USART_ITConfig(USART2,USART_IT_RXNE,ENABLE);

    DMA7_NVIC_Config();
    DMA6_NVIC_Config();

    //ʹDMAڹ

    USART_Cmd(USART2, ENABLE);
    //    DMA_Cmd(DMA1_Channel7, ENABLE); /* USART2 Tx */
    DMA_Cmd(DMA1_Channel6, ENABLE); /* USART2 Rx */
}

/*********************************************************************
 * @fn      DMA_INIT
 *
 * @brief   Configures the DMA for USART2 & USART3.
 *
 * @return  none
 */
void DMA_INIT(void)
{
    u8 ii=0;
    // 1. ʱ
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

    // ջ
    for (ii = 0; ii < RXBUF_MAX; ++ii) {
        RxBuffer1[ii] = 0;
    }
    rxBufPos = 0;
    // ÷ͻ
    TxBuffer1[0]=0xEB;
    TxBuffer1[1]=0x90;
    TxBuffer1[2]=USART_LOC_NOD_NUM;
    halfChkSum = TxBuffer1[0]^TxBuffer1[1]^TxBuffer1[2];
    TxBuffer1[4]=0x00;
    TxBuffer1[5]=0x00;

    // 2. ÷DMAϢڷDMA̶˲
    // USART2_TXDMAͨ7ͨ
    Tx_DMA_INIT(DMA1_Channel7, TXBUF_FUN01_SIZE,0);
    // 3. DMAãΪҪýջС˴ú
    //USART2_RXDMAͨ6DMAջСΪ1

    rxBufLen = 1;
    Rx_DMA_INIT(DMA1_Channel6,rxBufLen,rxBufPos);
}

void Tx_DMA_INIT(DMA_Channel_TypeDef *DMAy_Channelx,u32 bufSize, u32 bufBeginPos)
{

    DMA_DeInit(DMAy_Channelx);
    DMA_TxInitStruct.DMA_PeripheralBaseAddr = (u32)(&USART2->DATAR); /* USART2->DATAR:0x40004404 */
    DMA_TxInitStruct.DMA_MemoryBaseAddr = (u32)(TxBuffer1+bufBeginPos);
    DMA_TxInitStruct.DMA_DIR = DMA_DIR_PeripheralDST;
    DMA_TxInitStruct.DMA_BufferSize = TXBUF_FUN01_SIZE;
    DMA_TxInitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_TxInitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_TxInitStruct.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_TxInitStruct.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_TxInitStruct.DMA_Mode = DMA_Mode_Normal;
    DMA_TxInitStruct.DMA_Priority = DMA_Priority_VeryHigh;
    DMA_TxInitStruct.DMA_M2M = DMA_M2M_Disable;
    DMA_Init(DMAy_Channelx, &DMA_TxInitStruct);
}

void USART_DMA_SendOnce()
{
    DMA_ITConfig(DMA1_Channel7, DMA_IT_TC|DMA_IT_TE, ENABLE);
    Tx_DMA_INIT(DMA1_Channel7, TXBUF_FUN01_SIZE,0);
    DMA_Cmd(DMA1_Channel7, ENABLE);
}


void USART_DMA_SendAck(u8 funCode, u8 ackCode)
{
    //д:Ӧ
    TxBuffer1[3]=funCode;
    TxBuffer1[4]=ackCode;
    TxBuffer1[5]=halfChkSum ^TxBuffer1[3]^TxBuffer1[4];
    //һη
    USART_DMA_SendOnce();
}

void USART_DMA_RxSizeSet(u8 rxSize,u8 rxPos)
{
    DMA_Cmd(DMA1_Channel6, DISABLE); // 1. رʹ
    DMA1_Channel6->CNTR = rxSize;  //2. ûС
    DMA1_Channel6->MADDR = (u32)(RxBuffer1+rxPos); // 3.ıջλ
    DMA_Cmd(DMA1_Channel6, ENABLE); //4. ʹͨ
}

void Rx_DMA_INIT(DMA_Channel_TypeDef *DMAy_Channelx, u32 bufSize,u32 bufBeginPos)
{
    DMA_DeInit(DMAy_Channelx);
    DMA_RxInitStruct.DMA_PeripheralBaseAddr = (u32)(&USART2->DATAR);
    DMA_RxInitStruct.DMA_MemoryBaseAddr = (u32)(RxBuffer1+bufBeginPos);
    DMA_RxInitStruct.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_RxInitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_RxInitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_RxInitStruct.DMA_BufferSize = bufSize;
    DMA_RxInitStruct.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_Init(DMAy_Channelx, &DMA_RxInitStruct);
}




