/********************************** (C) COPYRIGHT *******************************
* File Name          : usart.h
* Author             : NUC
* Version            : V1.0.0
* Date               : 2022/07/30
* Description        : Main program body.
*******************************************************************************/

#ifndef USER_USART_H_
#define USER_USART_H_

#include "debug.h"
#include "ch32v30x_rcc.h"
#include "ch32v30x_gpio.h"
#include "ch32v30x_usart.h"
#include "ch32v30x_dma.h"


/* Global define */
#define TXBUF_FUN01_SIZE  6
#define RXBUF_FUN01_SIZE  5
#define TXBUF_MAX  16
#define RXBUF_MAX  16

#define USART_LOC_NOD_NUM     0x01  //ؽڵ
#define USART_FUN_RTCSET      0x01  //ܺ

#define USART_ACK_OK          0x00  //ӦOK
#define USART_ACK_NG          0x01  //ӦNG

#define USART_RX_FLG0         0x00   //ɶҲû
#define USART_RX_FLG1         0x01   //EB
#define USART_RX_FLG2         0x02   //90
#define USART_RX_FLG3         0x03   //ַ
#define USART_RX_FLG4         0x04   //깦
#define USART_RX_FLG5         0x05   //


/* Global Variable */
extern u8 TxBuffer1[TXBUF_MAX] ;
extern u8 RxBuffer1[RXBUF_MAX];   /* USART2 Using  */
extern u8 TxCnt1 ;
extern u8 RxCnt1 ;
extern u8 Rxfinish1 ;
extern u8 halfChkSum;

extern u8 rxFlag ;
extern u8 rxBufPos ;
extern u8 rxChkSum ;
extern u8 rxBufLen;


void USARTx_CFG(void);
void DMA_INIT(void);
void Rx_DMA_INIT(DMA_Channel_TypeDef *DMAy_Channelx, u32 bufSize,u32 bufBeginPos);
void Tx_DMA_INIT(DMA_Channel_TypeDef *DMAy_Channelx,u32 bufSize, u32 bufBeginPos);
void USART_DMA_SendOnce();
void USART_DMA_SendAck(u8 funCode, u8 ackCode);
void USART_DMA_RxSizeSet(u8 rxSize,u8 rxPos);




#endif /* USER_USART_H_ */
